<template>
    <div class="row">
        <div class="col-md-8">
            <div class="card card-default">
                <div class="card-header">
                    Message
                </div>
                <ul class="list-unstyled" style="height: 300px;overflow-y:scroll" vue-chat-scroll>
                    <li class="p-2" v-for="(message,index) in message" :key="index">
                        <strong>{{ message.user.name}}</strong>
                        {{ message.message }}
                    </li>
                </ul>
            </div>
            <input
                @keydown="sentTypingEvent"
                @keyup.enter="sentMessage"
                v-model ="newMessage"
                type="text" name="message" placeholder="write message here" class="form-control">
            <span class="text-muted" v-if="active"> {{ activeUser.name }} is typing</span>
        </div>
        <div class="col-md-4">
            <div class="card card-default">
                <div class="card-header"> Active user</div>
                <div class="card-body">
                    <ul>
                        <li class="p-2" v-for="(user,index) in users" :key="index">{{user.name}}</li>
                    </ul>
                </div>
            </div>

        </div>
    </div>
</template>

<script>
    export default {
        props:['user'],
        data(){
            return {
                message:[],
                newMessage: '',
                users: [],
                active: false,
                activeUser:'',
            }
        },
        created() {
            this.getMessage();
            Echo.join('message')
                .here(user=>{
                    this.users = user;
                })
                .joining(user => {
                    this.users.push(user);
                })
                .leaving(user => {
                    this.users = this.users.filter(u => u.id !== user.id)
                })
                .listen('MessageEvent',(event)=>{
                   this.message.push(event.message);
                })
                .listenForWhisper('typing',user=> {
                    this.active = true;
                    this.activeUser =user;
                });
        },
        methods: {
            getMessage(){
                axios.get('message').then(response =>{
                    this.message = response.data;
                });
            },
            sentMessage(){
                this.message.push({
                    user: this.user,
                   message:this.newMessage,
                });
                axios.post('message',{message: this.newMessage});
                this.newMessage = '';
            },
            sentTypingEvent(){
                this.active = true;
                Echo.join('message')
                    .whisper('typing',this.user);
            }
        }
    }
</script>
